#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <list>

struct account
{
	int acc_num;
	int bank_num;
	float funds;
};

int get_account(account *bank,int size,int cislo,int banka)
{
	int i;
	if(size==0) return -1;
	for(i=0;i<size;i++)
	{
		if(bank[i].acc_num==cislo && bank[i].bank_num==banka)
		{
			return i;
		}
	}
	return -1;
}

bool deposit(account *bank,int size,bool deb)
{
	int m_acc;
	int m_bank;
	float m_val;
	scanf("%d/%d %f",&m_acc,&(m_bank),&m_val); //kam

	if(deb)
		printf("deposit %.2f:",m_val);

	int pointer=get_account(bank,size,m_acc,m_bank);
	if(pointer!=-1)
	{
		bank[pointer].funds+=m_val;
		if(deb)
			printf(" ok\n");
		return true;
	}
	if(deb)
		printf(" no such account\n");
	return false;
}

bool withdraw(account *bank,int size,bool deb)
{
	int m_acc;
	int m_bank;
	float m_val;
	scanf("%d/%d %f",&m_acc,&(m_bank),&m_val); //odkial

	if(deb)
		printf("withdraw %.2f:",m_val);

	int pointer=get_account(bank,size,m_acc,m_bank);

	if(pointer==-1)
	{
		if(deb)
			printf(" no such account\n");
		return false;
	}

	if(bank[pointer].funds>=m_val)
	{
		bank[pointer].funds-=m_val;
		if(deb)
			printf(" ok\n");
		return true;
	}
	else
	{	
		if(deb)
			printf(" insufficient funds\n");
		return false;
	}
	return false;
}

bool transfer(account *bank,int size,bool deb)
{
	int m_acc_s;
	int m_bank_s;
	scanf("%d/%d",&m_acc_s,&(m_bank_s)); //odkial	
	int m_acc_d;
	int m_bank_d;
	float m_val;
	scanf("%d/%d %f",&m_acc_d,&(m_bank_d),&m_val); //kam a kolko
	int pointer_s,pointer_d;
	pointer_s=get_account(bank,size,m_acc_s,m_bank_s);
	pointer_d=get_account(bank,size,m_acc_d,m_bank_d);
	if(pointer_s==-1 || pointer_d==-1)
	{
		if(deb)
			printf(" no such account\n");
		return false;
	}
	if(pointer_s==pointer_d)
	{
		if(deb)
			printf(" same account\n");
		return false;
	}
	if(bank[pointer_s].funds<m_val)
	{
		if(deb)
			printf(" insufficient funds\n");
		return false;
	}
	if(bank[pointer_s].bank_num!=bank[pointer_d].bank_num)
	{
		if(deb)
			printf(" interbank\n");
	}
	else if(deb) printf(" ok\n");
	bank[pointer_s].funds-=m_val;
	bank[pointer_d].funds+=m_val;
	return true;
}


bool create_account(account *bank,int size,int uctov,bool deb)
{
	int i;
	int m_acc;
	int m_bank;
	scanf("%d/%d",&m_acc,&m_bank);
	if(deb)
		printf("create:");
	if(get_account(bank,size,m_acc,m_bank)!=-1)
	{
		
	}
	//ak nie
	bank[size].acc_num=m_acc;
	bank[size].bank_num=m_bank;
	bank[size].funds=0;
	if(deb)
		printf(" ok");
	return true;
	
}

void do_bank(int start_acc)
{
	account bank[1100];
	int i;
	int accounts=0;
	char order[10];
	for(i=0;i<start_acc;i++)
	{
		create_account(bank,1100,accounts,false);
		deposit(bank,accounts,false);
		accounts++;
		
	}
	//ide spacovavavat prikazy
	scanf("%s",order);
	while(strcmp("end",order)!=0)
	{
		if(strcmp("create",order)==0) {if(create_account(bank,1100,accounts,true)) accounts++;}
		else if(strcmp("deposit",order)==0) deposit(bank,accounts,true);
		else if(strcmp("withdraw",order)==0) withdraw(bank,accounts,true);
		else if(strcmp("transfer",order)==0) transfer(bank,accounts,true);
		else {printf ("error\n");return;}
	}
	printf("end\n\n");
}

int main()
{
	int s_a;
	scanf("%d",&s_a);
	printf("%d\n",s_a);
	while(s_a>0)
	{
		do_bank(s_a);
		scanf("%d",&s_a);
	}
	return 0;	
}
