#include <stdio.h>

void print_array(int* pole,int size)
{
	int i;
	for(i=0;i<size;i++)
	{
		printf("%d ",pole[i]);
	}
}

int get_min(int* prvky,int size)
{
	int i;
	int temp=prvky[0];
	for(i=1;i<size;i++)
	{
		temp=temp<prvky[i]?temp:prvky[i];
	}
	return temp;
}

int get_max(int* prvky,int start,int prvkov,int size)
{
	int temp=prvky[start];
	int i;
//	printf("temp:%d\n",temp); //debug
	for(i=1;i<prvkov;i++)
	{
		if(temp<=prvky[(start+i)%size])
			temp=prvky[(start+i)%size];
//		printf("temp:%d i:%d\n",temp,i); //debug
	}
	return temp;	
}

void do_gamble(int size)
{
	int cisla[size];
	int vaha[size];
	int max[size];
	int suma=0;
	int i;
	int usek=(size-1)/2;
	for(i=0;i<size;i++)
	{
		scanf("%d",cisla+i);
		suma+=cisla[i];
	}
	//vypocet pre prvy prvok 0
	vaha[0]=0;
	for(i=0;i<usek;i++)
	{
		vaha[0]+=cisla[i];
	}
	//printf("%d\n\n",vaha[0]);
	//prvky 1 a viac
	for(i=1;i<size;i++)
	{
		vaha[i]=vaha[i-1]-cisla[i-1]+cisla[(i+usek-1)%size];
	}
	//vypocet max pre prvok 0
	max[0]=get_max(cisla,0,usek,size);
	//vypocet max pre ostatne
	for(i=1;i<size;i++)
	{
		if(max[i-1]==cisla[i-1])
		{
			max[i]=get_max(cisla,i,usek,size);
		}
		else
		{
			max[i]=max[i-1]>cisla[(i+usek-1)%size]?max[i-1]:cisla[(i+usek-1)%size];
		}
	}
	for(i=0;i<size;i++)
	{
		vaha[i]-=max[i];
	}
	printf("%d\n",get_min(vaha,size)+suma);
}

int main()
{
	int velkost;
	scanf("%d",&velkost);
	while(velkost>0)
	{
		do_gamble(velkost);
		scanf("%d",&velkost);		
	}
	return 0;
}
